<?php
/*--------------------------------------------+
| GameStatusViewer     V 1.0     2005-07-26   |
| Gamespy1 Protocoll                          |
|---------------------------------------------|
| Copyright Makro (Markus Kronier)  2005     |
| web: http://www.makromobil.de               |
| email: makro@makromobil.de                  |
|---------------------------------------------|
| Released under the terms and conditions of  |
| the GNU General Public License (Version 2)  |
+--------------------------------------------*/

class CProt_GameSpy {

  var $m_serverIp;
  var $m_queryPort;

  //---------------
  var $m_requestCmd          = array();
  //---------------

  var $m_serverData;

  function CProt_GameSpy($serverIp, $queryPort) {
    $this->m_serverIp        = $serverIp;
    $this->m_queryPort       = $queryPort;
    //$this->m_requestCmd[]        = "\\info\\";  "\\rules\\"; "\\players\\";
    $this->m_requestCmd[]          = "\\status\\";
  }

  function ReadServerData() {
    $error = "";
    $this->m_serverData = '';

    $socket = @fsockopen('udp://'. $this->m_serverIp, $this->m_queryPort, $errno, $errstr, 10);
    if ($socket) {
      socket_set_timeout($socket, 2);
      foreach ($this->m_requestCmd as $reqCmd) {
        //--- Send request to Server
        fwrite($socket, $reqCmd);

        //--- Read response
        do {
          $part = fread($socket,2048);
          if ($part) $this->m_serverData .= $part;
        } while (($part != "") && (!strpos($part, "\\final\\")));
      }
      fclose($socket);
    } else {
      $error = "not connected to the server!";
    }
    return $error;
  }

  function GetGameData() {
    $data     = explode("\\", $this->m_serverData);
    $gameData = array();

    $gameData["hostip"] = $this->m_serverIp;
    $gameData["queryport"] = $this->m_queryPort;
    $i = 1;
    while ($i < count($data)-1) {
      $gameData[$data[$i]]= $data[$i+1];
      $i+=2;
    }
    return $gameData;
  }

  function GetPlayerData() {
    $data       = explode("\\", $this->m_serverData);
    $playerData = array();
    $i = 1;
    while ($i < count($data)-1) {
      $playerData[$data[$i]]= $data[$i+1];
      $i+=2;
    }
    return $playerData;
  }
}

?>